// Copyright 2005 DJ Delorie

// Temp is hundredths, giving a -327.68 to 327.67 F range.
// Humidity is halves, giving a 0.0% to 127.5% range.
// Fractions are always 0..255, with 0=0% and 255=100%.

#pragma pack(1)

typedef struct {
  unsigned long time;
  signed short temp[4];
  unsigned char humidity[4];
  struct {
    unsigned char heat:1;
    unsigned char cool:1;
    unsigned char fan:1;
    unsigned char humidify:1;
    unsigned char zone0:1;
    unsigned char zone1:1;
    unsigned char zone2:1;
    unsigned char zone3:1;
  } furnace;
} LogEvent;

typedef struct {
  unsigned long start_time;
  unsigned long end_time;
  struct {
    signed short max_temp;
    signed short min_temp;
    unsigned char max_humidity;
    unsigned char min_humidity;
    /* 0=0% 255=100% */
    unsigned char frac_heat;
    unsigned char frac_cool;
    unsigned char frac_fan;
    unsigned char frac_humidify;
  } zone[4];
} LogSummary;

#pragma pack()
