// Copyright 2005 DJ Delorie

#ifndef DEST_ALL
#define DEST_ALL	0
#define DEST_MUX	1
#endif

#if defined(MT_NAMELIST)
#define MT(x) #x
const char *MsgTypeNames[] = {
#else
#define MT(x) MT_##x
extern const char *MsgTypeNames[];
typedef enum {
#endif

  // data is ignored
  MT(NOP),

  // first byte of data is zero or nonzero, dest must be DEST_MUX
  MT(snoop),

  // data is ASCIIZ name of sender.  Reply with my_name
  MT(ask_name),
  // data is ASCIIZ name of sender.  No reply.
  MT(my_name),

  // data is ASCIIZ var name.  Reply with var_name
  MT(ask_var_id),
  // data is int for id, ASCIIZ var name.
  MT(var_id),
  // data is int for id, value.
  MT(set_var_value),
  // data is int for id.  Reply with set_var_value.
  MT(ask_var_value),

  // first byte is always ZONE for zone-related messages.

  // no data, reply with set_furnace
  MT(ask_furnace),
  // data is FurnaceData
  MT(set_furnace),

  // data is ButtonData.  Sent when needed.
  MT(button),
  // data is ClimateData.  Sent at intervals.
  MT(climate),

  // data is (char) zone (char[]) data
  MT(lcd),
  // data is (short) msec
  MT(lcd_pause),

  MT(MAX)

#if defined(MT_NAMELIST)
};
#else
} MsgType;
#endif
#undef MT
