// Copyright 2005 DJ Delorie
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "msg.h"
#include "vars.h"

Message *
get_typed_message (int type)
{
  Message *m;
  while ((m = Message::next(1000)))
    {
      //      printf("%4d %02d->%02d %04x\n", m->type, m->source, m->dest, m->type);
      if (m->type == type)
	return m;
    }
  printf("timeout!\n");
  exit(0);
}

int
main(int argc, char **argv)
{
  if (argc > 2 && strcmp (argv[1], "-h") == 0)
    {
      Message::set_host (argv[2]);
      argv += 2;
      argc -= 2;
    }

  char *name = argc > 1 ? argv[1] : 0;
  char *valstr = argc > 2 ? argv[2] : 0;
  VarValueType v;
  Message *m;

  Message::set_my_name("vartest");
  Message::init();

  if (!name)
    exit(0);

  Message nameid(name, strlen(name)+1, MT_ask_var_id);
  nameid.send();
  VarIdData *vid;
  while (m = get_typed_message(MT_var_id))
    {
      vid = (VarIdData *)m->data;
      printf("got one for %s\n", vid->name);
      if (strcmp (vid->name, name) == 0)
	break;
    }
  printf("Var %s id %d\n", vid->name, vid->id);
  vid = (VarIdData *)malloc (m->length);
  memcpy (vid, m->data, m->length);

  SetVarValueData svd;

  Message getval(&vid->id, sizeof(vid->id), MT_ask_var_value);
  getval.send();
  while (m = get_typed_message(MT_set_var_value))
    {
      svd = *(SetVarValueData *)m->data;
      printf("got one for %d\n", svd.id);
      if (svd.id == vid->id)
	break;
    }
  printf("Var %s [%d] was %f\n", name, svd.id, svd.value);

  if (!valstr)
    exit(0);

  svd.id = vid->id;
  svd.value = strtod (valstr, 0);
  Message setval(&svd, sizeof(svd), MT_set_var_value);
  setval.dest = m->source;
  setval.send();
  printf("Setting %s to   %f\n", name, svd.value);

  exit(0);
}
